<!-- markdownlint-disable -->
<h1 align="center">
    best-of-ml-rust
    <br>
</h1>

<p align="center">
    <strong>🏆&nbsp; A ranked list of awesome machine learning Rust libraries. Updated weekly.</strong>
</p>

<p align="center">
    <a href="https://best-of.org" title="Best-of Badge"><img src="http://bit.ly/3o3EHNN"></a>
    <a href="#Contents" title="Project Count"><img src="https://img.shields.io/badge/projects-130-blue.svg?color=5ac4bf"></a>
    <a href="#Contribution" title="Contributions are welcome"><img src="https://img.shields.io/badge/contributions-welcome-green.svg"></a>
    <a href="https://github.com/e-tony/best-of-ml-rust/releases" title="Best-of Updates"><img src="https://img.shields.io/github/release-date/e-tony/best-of-ml-rust?color=green&label=updated"></a>
</p>

This curated list contains 130 awesome open-source projects with a total of 67K stars grouped into 5 categories. All projects are ranked by a project-quality score, which is calculated based on various metrics automatically collected from GitHub and different package managers. If you like to add or update projects, feel free to open an [issue](https://github.com/e-tony/best-of-ml-rust/issues/new/choose), submit a [pull request](https://github.com/e-tony/best-of-ml-rust/pulls), or directly edit the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml). Contributions are very welcome!

> 🧙‍♂️  Discover other [best-of lists](https://best-of.org) or [create your own](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

## Contents

- [Machine Learning Frameworks](#machine-learning-frameworks) _67 projects_
- [Text Data & NLP](#text-data--nlp) _46 projects_
- [Image Data](#image-data) _10 projects_
- [Data Loading & Extraction](#data-loading--extraction) _6 projects_
- [Graph Data](#graph-data) _3 projects_

## Explanation
- 🥇🥈🥉&nbsp; Combined project-quality score
- ⭐️&nbsp; Star count from GitHub
- 🐣&nbsp; New project _(less than 6 months old)_
- 💤&nbsp; Inactive project _(6 months no activity)_
- 💀&nbsp; Dead project _(12 months no activity)_
- 📈📉&nbsp; Project is trending up or down
- ➕&nbsp; Project was recently added
- ❗️&nbsp; Warning _(e.g. missing/risky license)_
- 👨‍💻&nbsp; Contributors count from GitHub
- 🔀&nbsp; Fork count from GitHub
- 📋&nbsp; Issue count from GitHub
- ⏱️&nbsp; Last update timestamp on package manager
- 📥&nbsp; Download count from package manager
- 📦&nbsp; Number of dependent projects
- <img src="🎁" style="display:inline;" width="13" height="13">&nbsp; A binding for another project.

<br>

## Machine Learning Frameworks

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_General-purpose machine learning and deep learning frameworks._

<details><summary><b><a href="https://github.com/rusoto/rusoto">rusoto</a></b> (🥇20 ·  ⭐ 2.3K) - AWS SDK for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/rusoto/rusoto) (👨‍💻 180 · 🔀 350 · 📋 860 - 21% open · ⏱️ 28.01.2021):

	```
	git clone https://github.com/rusoto/rusoto
	```
</details>
<details><summary><b><a href="https://github.com/apache/tvm">tvm</a></b> (🥇18 ·  ⭐ 6.5K) - Open deep learning compiler stack for cpu, gpu and specialized.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/apache/tvm) (👨‍💻 520 · 🔀 1.8K · 📥 540 · 📋 1.8K - 7% open · ⏱️ 12.04.2021):

	```
	git clone https://github.com/apache/tvm
	```
</details>
<details><summary><b><a href="https://github.com/weld-project/weld">weld</a></b> (🥇17 ·  ⭐ 2.6K · 💤) - High-performance runtime for data analytics applications. <code><a href="http://bit.ly/3aKzpTv">BSD-3</a></code></summary>

- [GitHub](https://github.com/weld-project/weld) (👨‍💻 36 · 🔀 230 · 📦 2 · 📋 160 - 41% open · ⏱️ 04.04.2020):

	```
	git clone https://github.com/weld-project/weld
	```
</details>
<details><summary><b><a href="https://github.com/dimforge/nalgebra">nalgebra</a></b> (🥇17 ·  ⭐ 2.1K · ➕) - Linear algebra library for Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/dimforge/nalgebra) (👨‍💻 130 · 🔀 250 · 📋 440 - 35% open · ⏱️ 12.04.2021):

	```
	git clone https://github.com/dimforge/nalgebra
	```
</details>
<details><summary><b><a href="https://github.com/tensorflow/rust">rust</a></b> (🥇16 ·  ⭐ 3K) - Rust language bindings for TensorFlow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/tensorflow/rust) (👨‍💻 37 · 🔀 240 · 📋 130 - 21% open · ⏱️ 18.02.2021):

	```
	git clone https://github.com/tensorflow/rust
	```
</details>
<details><summary><b><a href="https://github.com/ballista-compute/ballista">ballista</a></b> (🥇16 ·  ⭐ 2.2K) - Distributed compute platform implemented in Rust, and powered by.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/ballista-compute/ballista) (👨‍💻 37 · 🔀 140 · ⏱️ 11.04.2021):

	```
	git clone https://github.com/ballista-compute/ballista
	```
</details>
<details><summary><b><a href="https://github.com/xaynetwork/xaynet">xaynet</a></b> (🥇16 ·  ⭐ 120) - Xaynet represents an agnostic Federated Machine Learning framework to.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/xaynetwork/xaynet) (👨‍💻 28 · 🔀 18 · 📋 30 - 10% open · ⏱️ 31.03.2021):

	```
	git clone https://github.com/xaynetwork/xaynet
	```
</details>
<details><summary><b><a href="https://github.com/PyO3/rust-numpy">rust-numpy</a></b> (🥈15 ·  ⭐ 440) - PyO3-based Rust binding of NumPy C-API. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code></summary>

- [GitHub](https://github.com/PyO3/rust-numpy) (👨‍💻 25 · 🔀 57 · 📋 59 - 22% open · ⏱️ 11.04.2021):

	```
	git clone https://github.com/PyO3/rust-numpy
	```
</details>
<details><summary><b><a href="https://github.com/maciejkula/rustlearn">rustlearn</a></b> (🥈13 ·  ⭐ 490 · 💤) - Machine learning crate for Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/maciejkula/rustlearn) (👨‍💻 9 · 🔀 43 · 📋 12 - 66% open · ⏱️ 21.06.2020):

	```
	git clone https://github.com/maciejkula/rustlearn
	```
</details>
<details><summary><b><a href="https://github.com/boxtown/statrs">statrs</a></b> (🥈13 ·  ⭐ 240 · ➕) - Statistical computation library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/boxtown/statrs) (👨‍💻 20 · 🔀 35 · 📋 86 - 22% open · ⏱️ 31.03.2021):

	```
	git clone https://github.com/boxtown/statrs
	```
</details>
<details><summary><b><a href="https://github.com/granne/granne">granne</a></b> (🥈13 ·  ⭐ 230 · 💤) - Graph-based Approximate Nearest Neighbor Search. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/granne/granne) (👨‍💻 5 · 🔀 19 · 📋 11 - 27% open · ⏱️ 29.09.2020):

	```
	git clone https://github.com/granne/granne
	```
</details>
<details><summary><b><a href="https://github.com/raskr/rust-autograd">rust-autograd</a></b> (🥈12 ·  ⭐ 280) - Tensors and differentiable operations (like TensorFlow) in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/raskr/rust-autograd) (👨‍💻 10 · 🔀 20 · ⏱️ 31.12.2020):

	```
	git clone https://github.com/raskr/rust-autograd
	```
</details>
<details><summary><b><a href="https://github.com/bilal2vec/L2">L2</a></b> (🥈11 ·  ⭐ 130) - l2 is a fast, Pytorch-style Tensor+Autograd library written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bilal2vec/L2) (🔀 13 · ⏱️ 04.02.2021):

	```
	git clone https://github.com/bilal2vec/L2
	```
</details>
<details><summary>Show 54 hidden projects...</summary>

- <b><a href="https://github.com/sonos/tract">tract</a></b> (🥈15 ·  ⭐ 920) - Tiny, no-nonsense, self-contained, Tensorflow and ONNX inference. <code>❗Unlicensed</code>
- <b><a href="https://github.com/wsmoses/Enzyme">Enzyme</a></b> (🥈15 ·  ⭐ 450) - High-performance automatic differentiation of LLVM. <code>❗Unlicensed</code>
- <b><a href="https://github.com/google/evcxr">evcxr</a></b> (🥈14 ·  ⭐ 2.4K · ➕) -  <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/rust-ml/linfa">linfa</a></b> (🥈14 ·  ⭐ 850) - A Rust machine learning framework. <code>❗Unlicensed</code>
- <b><a href="https://github.com/AtheMathmo/rusty-machine">rusty-machine</a></b> (🥈13 ·  ⭐ 1.2K · 💀) - Machine Learning library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/spearow/juice">juice</a></b> (🥈13 ·  ⭐ 770) - The Hacker's Machine Learning Engine. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Azure/azure-sdk-for-rust">azure-sdk-for-rust</a></b> (🥈13 ·  ⭐ 94) - This repository is for active development of the.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/autumnai/leaf">leaf</a></b> (🥈12 ·  ⭐ 5.5K · 💀) - Open Machine Intelligence Framework for Hackers. (GPU/CPU). <code>❗Unlicensed</code>
- <b><a href="https://github.com/LaurentMazare/tch-rs">tch-rs</a></b> (🥈12 ·  ⭐ 1K) - Rust bindings for the C++ api of PyTorch. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/Synerise/cleora">cleora</a></b> (🥈12 ·  ⭐ 310 · 🐣) - Cleora AI is a general-purpose model for efficient, scalable.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/vertexclique/orkhon">orkhon</a></b> (🥈12 ·  ⭐ 98) - Orkhon: ML Inference Framework and Server Runtime. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/vbarrielle/sprs">sprs</a></b> (🥈11 ·  ⭐ 230 · ➕) - sparse linear algebra library for rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Axect/Peroxide">Peroxide</a></b> (🥈11 ·  ⭐ 200) - Rust numeric library with R, MATLAB & Python syntax. <code>❗Unlicensed</code>
- <b><a href="https://github.com/tspooner/rsrl">rsrl</a></b> (🥈11 ·  ⭐ 98 · 💤) - A fast, safe and easy to use reinforcement learning framework in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/MrRobb/gym-rs">gym-rs</a></b> (🥈11 ·  ⭐ 32 · 💤) - OpenAI Gym bindings for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/milesgranger/black-jack">black-jack</a></b> (🥈11 ·  ⭐ 25 · ➕) - DataFrame / Series data processing in Rust. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/jackm321/RustNN">RustNN</a></b> (🥉10 ·  ⭐ 300 · 💀) - A neural network crate. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tedsta/deeplearn-rs">deeplearn-rs</a></b> (🥉10 ·  ⭐ 190 · 💀) - Neural networks in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/millardjn/alumina">alumina</a></b> (🥉10 ·  ⭐ 77) - A deep learning library for rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/torchrs/torchrs">torchrs</a></b> (🥉10 ·  ⭐ 76 · 💀) - Deep Learning in Rust with the PyTorch API. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/ralfbiedert/ffsvm-rust">ffsvm-rust</a></b> (🥉10 ·  ⭐ 41 · 💀) - FFSVM stands for Really Fast Support Vector Machine. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/Enet4/faiss-rs">faiss-rs</a></b> (🥉10 ·  ⭐ 37 · ➕) - Rust language bindings for Faiss. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/milanboers/rurel">rurel</a></b> (🥉10 ·  ⭐ 27 · ➕) - Flexible, reusable reinforcement learning (Q learning) implementation.. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/emakryo/rustdef">rustdef</a></b> (🥉10 ·  ⭐ 10 · ➕) - Jupyter extension for rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/smartcorelib/smartcore">smartcore</a></b> (🥉9 ·  ⭐ 120) - SmartCore is a comprehensive library for machine learning and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/MikhailKravets/NeuroFlow">NeuroFlow</a></b> (🥉9 ·  ⭐ 53 · 💀) - Awesome deep learning crate. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/bminixhofer/tractjs">tractjs</a></b> (🥉9 ·  ⭐ 50) - Run ONNX and TensorFlow inference in the browser. <code>❗Unlicensed</code>
- <b><a href="https://github.com/daniel-e/rustml">rustml</a></b> (🥉9 ·  ⭐ 46 · 💀) - Machine learning in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/mrhooray/kdtree-rs">kdtree-rs</a></b> (🥉8 ·  ⭐ 96 · ➕) - K-dimensional tree in Rust for fast geospatial indexing and.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jramapuram/hal">hal</a></b> (🥉8 ·  ⭐ 75 · 💀) - Rust based Cross-GPU Machine Learning. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/diffeo/kodama">kodama</a></b> (🥉8 ·  ⭐ 49) - Fast hierarchical agglomerative clustering in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/avinashshenoy97/RusticSOM">RusticSOM</a></b> (🥉8 ·  ⭐ 20) - Rust library for Self Organising Maps (SOM). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/lerouxrgd/ngt-rs">ngt-rs</a></b> (🥉8 ·  ⭐ 8 · ➕) - Rust wrappers for NGT approximate nearest neighbor search. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/charles-r-earp/autograph">autograph</a></b> (🥉7 ·  ⭐ 110) - Machine Learning Library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/metamolecular/gamma">gamma</a></b> (🥉7 ·  ⭐ 100 · ➕) - A graph library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/outbrain/fwumious_wabbit">fwumious_wabbit</a></b> (🥉7 ·  ⭐ 97) - Fwumious Wabbit, fast on-line machine learning toolkit.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-cv/hnsw">hnsw</a></b> (🥉7 ·  ⭐ 50 · 💤) - HNSW ANN from the paper Efficient and robust approximate nearest neighbor.. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code>
- <b><a href="https://github.com/boncheolgu/tflite-rs">tflite-rs</a></b> (🥉7 ·  ⭐ 39) -  <code>❗Unlicensed</code>
- <b><a href="https://github.com/JonathanWoollett-Light/cogent">cogent</a></b> (🥉7 ·  ⭐ 25) - Simple neural network library for classification written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/epwalsh/rust-dl-webserver">rust-dl-webserver</a></b> (🥉7 ·  ⭐ 17) - Example of serving deep learning models in Rust with.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/messense/crfsuite-rs">crfsuite-rs</a></b> (🥉7 ·  ⭐ 13) - Rust binding to crfsuite. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/CasperN/drug">drug</a></b> (🥉7 ·  ⭐ 10 · 💀) - Differentiable Rust Graphs (neural network library). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/rust-cv/hwt">hwt</a></b> (🥉7 ·  ⭐ 6 · 💀) - Hamming Weight Tree from the paper Online Nearest Neighbor Search in Hamming.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/shadeMe/liblinear-rs">liblinear-rs</a></b> (🥉7 ·  ⭐ 5 · 💀) - Rust language bindings for the LIBLINEAR C/C++ library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/c0dearm/mushin">mushin</a></b> (🥉6 ·  ⭐ 160 · ➕) - Compile-time creation of neural networks. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Robbepop/prophet">prophet</a></b> (🥉6 ·  ⭐ 39 · 💀) - A simple neural net implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/kornelski/vpsearch">vpsearch</a></b> (🥉6 ·  ⭐ 25 · ➕) - C library for finding nearest (most similar) element in a set. <code>❗Unlicensed</code>
- <b><a href="https://github.com/yurytsoy/revonet">revonet</a></b> (🥉6 ·  ⭐ 14 · 💀) - Rust implementation of real-coded GA for solving optimization.. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/afck/fann-rs">fann-rs</a></b> (🥉6 ·  ⭐ 11 · 💀) - Rust wrapper for the Fast Artificial Neural Network library. <code><a href="http://bit.ly/37RvQcA">❗️LGPL-3.0</a></code>
- <b><a href="https://github.com/epwalsh/batched-fn">batched-fn</a></b> (🥉6 ·  ⭐ 3) - Rust middleware for serving deep learning models with batched.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/zenoxygen/bayespam">bayespam</a></b> (🥉6 ·  ⭐ 3 · ➕) - A simple bayesian spam classifier written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/liborty/rstats">rstats</a></b> (🥉6 ·  ⭐ 2 · ➕) - Rust Statistics and Vector Algebra Library. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/finalfusion/reductive">reductive</a></b> (🥉6) - Vector quantization. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/usamec/cntk-rs">cntk-rs</a></b> (🥉5 ·  ⭐ 20 · 💀) - Wrapper around Microsoft CNTK library. <code>❗Unlicensed</code>
</details>
<br>

## Text Data & NLP

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for processing, cleaning, manipulating, and analyzing text data as well as for diverse NLP tasks._

<details><summary><b><a href="https://github.com/huggingface/tokenizers">tokenizers</a></b> (🥇21 ·  ⭐ 4.4K) - Fast State-of-the-Art Tokenizers optimized for Research and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/huggingface/tokenizers) (👨‍💻 40 · 🔀 330 · 📦 31 · 📋 410 - 22% open · ⏱️ 05.04.2021):

	```
	git clone https://github.com/huggingface/tokenizers
	```
</details>
<details><summary><b><a href="https://github.com/pemistahl/grex">grex</a></b> (🥇17 ·  ⭐ 3.3K · 📈) - A command-line tool and library for generating regular expressions.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/pemistahl/grex) (👨‍💻 3 · 🔀 76 · 📥 2.7K · 📋 29 - 24% open · ⏱️ 28.03.2021):

	```
	git clone https://github.com/pemistahl/grex
	```
</details>
<details><summary><b><a href="https://github.com/greyblake/whatlang-rs">whatlang-rs</a></b> (🥇15 ·  ⭐ 420) - Natural language detection library for Rust. Try demo online:.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/greyblake/whatlang-rs) (👨‍💻 14 · 🔀 28 · 📋 35 - 8% open · ⏱️ 27.03.2021):

	```
	git clone https://github.com/greyblake/whatlang-rs
	```
</details>
<details><summary><b><a href="https://github.com/guillaume-be/rust-bert">rust-bert</a></b> (🥈13 ·  ⭐ 540) - Rust native ready-to-use NLP pipelines and transformer-based.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/guillaume-be/rust-bert) (👨‍💻 9 · 🔀 38 · 📋 40 - 17% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/guillaume-be/rust-bert
	```
</details>
<details><summary><b><a href="https://github.com/bminixhofer/nnsplit">nnsplit</a></b> (🥈13 ·  ⭐ 150) - Semantic text segmentation. For sentence boundary detection, compound.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bminixhofer/nnsplit) (👨‍💻 3 · 🔀 10 · 📦 2 · 📋 19 - 36% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/bminixhofer/nnsplit
	```
</details>
<details><summary><b><a href="https://github.com/pemistahl/lingua-rs">lingua-rs</a></b> (🥈12 ·  ⭐ 270 · 📉) - The most accurate natural language detection library in the.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/pemistahl/lingua-rs) (👨‍💻 2 · 🔀 4 · 📋 13 - 38% open · ⏱️ 08.04.2021):

	```
	git clone https://github.com/pemistahl/lingua-rs
	```
</details>
<details><summary><b><a href="https://github.com/lindera-morphology/lindera">lindera</a></b> (🥈11 ·  ⭐ 100) - A morphological analysis library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/lindera-morphology/lindera) (👨‍💻 6 · 🔀 12 · 📋 30 - 16% open · ⏱️ 16.01.2021):

	```
	git clone https://github.com/lindera-morphology/lindera
	```
</details>
<details><summary><b><a href="https://github.com/fancy-regex/fancy-regex">fancy-regex</a></b> (🥈10 ·  ⭐ 200) - Rust library for regular expressions using fancy features like look-.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/fancy-regex/fancy-regex) (👨‍💻 12 · 🔀 13 · 📋 13 - 15% open · ⏱️ 15.02.2021):

	```
	git clone https://github.com/fancy-regex/fancy-regex
	```
</details>
<details><summary>Show 38 hidden projects...</summary>

- <b><a href="https://github.com/bminixhofer/nlprule">nlprule</a></b> (🥇14 ·  ⭐ 320) - A fast, low-resource Natural Language Processing and Text.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/snipsco/snips-nlu-rs">snips-nlu-rs</a></b> (🥇14 ·  ⭐ 320 · 💀) - Snips NLU rust implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/aho-corasick">aho-corasick</a></b> (🥈11 ·  ⭐ 440) - A fast implementation of Aho-Corasick in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/christophertrml/rs-natural">rs-natural</a></b> (🥈11 ·  ⭐ 190 · 💀) - Natural Language Processing for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/snipsco/rustling-ontology">rustling-ontology</a></b> (🥈11 ·  ⭐ 110) - Ontology for rustling. <code>❗Unlicensed</code>
- <b><a href="https://github.com/snipsco/rustling">rustling</a></b> (🥈11 ·  ⭐ 62 · 💀) - Rust implementation of Duckling. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/snipsco/snips-nlu-ontology">snips-nlu-ontology</a></b> (🥈11 ·  ⭐ 55 · 💀) - Ontology of Snips NLU. <code>❗Unlicensed</code>
- <b><a href="https://github.com/finalfusion/finalfusion-rust">finalfusion-rust</a></b> (🥈11 ·  ⭐ 36) - finalfusion embeddings in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/guillaume-be/rust-tokenizers">rust-tokenizers</a></b> (🥈10 ·  ⭐ 80) - Rust-tokenizer offers high-performance tokenizers for modern.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/CurrySoftware/rust-stemmers">rust-stemmers</a></b> (🥈10 ·  ⭐ 61 · 💀) - A rust implementation of some popular snowball stemming.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/finalfusion/finalfrontier">finalfrontier</a></b> (🥈10 ·  ⭐ 60) - Context-sensitive word embeddings with subwords. In Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/proycon/deepfrog">deepfrog</a></b> (🥈10 ·  ⭐ 13 · 📈) - An NLP-suite powered by deep learning. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/rth/vtext">vtext</a></b> (🥉9 ·  ⭐ 110 · 💤) - Simple NLP in Rust with Python bindings. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/dpar">dpar</a></b> (🥉9 ·  ⭐ 39 · 💤) - Neural network transition-based dependency parser (in Rust). <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/stickeritis/sticker">sticker</a></b> (🥉9 ·  ⭐ 27) - Succeeded by SyntaxDot: https://github.com/tensordot/syntaxdot. <code>❗Unlicensed</code>
- <b><a href="https://github.com/pemistahl/chr">chr</a></b> (🥉9 ·  ⭐ 20) - A command-line tool that gives information about Unicode characters. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/snipsco/gazetteer-entity-parser">gazetteer-entity-parser</a></b> (🥉9 ·  ⭐ 14 · 💀) - Rust library for parsing and resolving entity values.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/snipsco/snips-nlu-parsers">snips-nlu-parsers</a></b> (🥉9 ·  ⭐ 11 · 💀) - Rust crate for entity parsing. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/sentencepiece">sentencepiece</a></b> (🥉9 ·  ⭐ 6) - Rust binding for the sentencepiece library. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/DimaKudosh/word2vec">word2vec</a></b> (🥉8 ·  ⭐ 20 · 💀) - Rust interface to word2vec. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/cmccomb/rust-stop-words">rust-stop-words</a></b> (🥉8 ·  ⭐ 3 · ➕) - Common stop words in a variety of languages. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/nakagami/awabi">awabi</a></b> (🥉8 ·  ⭐ 3 · ➕) - A morphological analyzer using mecab dictionary. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/messense/fasttext-rs">fasttext-rs</a></b> (🥉7 ·  ⭐ 27 · ➕) - fastText Rust binding. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/cpcdoy/rust-sbert">rust-sbert</a></b> (🥉7 ·  ⭐ 15) - Rust port of sentence-transformers.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/sebpuetz/lumberjack">lumberjack</a></b> (🥉7 ·  ⭐ 11 · 💀) - Read and modify constituency trees in Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tensordot/syntaxdot">syntaxdot</a></b> (🥉7 ·  ⭐ 10 · 🐣) - Neural syntax annotator, supporting sequence labeling,.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/alpino-tokenizer">alpino-tokenizer</a></b> (🥉7 ·  ⭐ 2) - Rust wrapper for the Alpino tokenizer. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/seqalign">seqalign</a></b> (🥉7 · 💤) - Sequence alignments. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/mklf/word2vec-rs">word2vec-rs</a></b> (🥉6 ·  ⭐ 25 · ➕) - pure rust implemention of word2vec. <code>❗Unlicensed</code>
- <b><a href="https://github.com/huggingface/spm_precompiled">spm_precompiled</a></b> (🥉6 ·  ⭐ 9) - Highly specialized crate to parse and use.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/bminixhofer/srx">srx</a></b> (🥉6 ·  ⭐ 3 · 🐣) - A mostly compliant Rust implementation of the Segmentation Rules.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/reinfer/blingfire-rs">blingfire-rs</a></b> (🥉5 ·  ⭐ 11 · 💤) - Rust wrapper for the BlingFire tokenization library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/allenai/rustberta-snli">rustberta-snli</a></b> (🥉5 ·  ⭐ 11 · 🐣) - A Rust implementation of a RoBERTa classification.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/ohnomore">ohnomore</a></b> (🥉5) - Explorations in lemmatization. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/wordpieces">wordpieces</a></b> (🥉4 ·  ⭐ 1) - Split tokens into word pieces. <code>❗Unlicensed</code>
- <b><a href="https://github.com/ferristseng/rust-tfidf">rust-tfidf</a></b> (🥉3 ·  ⭐ 9 · ➕) -  <code>❗Unlicensed</code>
- <b><a href="https://github.com/Aleph-Alpha/aleph-alpha-tokenizer">aleph-alpha-tokenizer</a></b> (🥉3 ·  ⭐ 5 · 💤) - A rustic language tokenizer library inspired by.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/andrew-johnson-4/misspeller">misspeller</a></b> (🥉3) - Take correctly spelled words and return common spelling mistakes. <code>❗Unlicensed</code>
</details>
<br>

## Image Data

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for image & video processing, manipulation, and augmentation as well as libraries for computer vision._

<details><summary><b><a href="https://github.com/rustgd/cgmath">cgmath</a></b> (🥇15 ·  ⭐ 780 · ➕) - A linear algebra and mathematics library for computer graphics. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/rustgd/cgmath) (👨‍💻 92 · 🔀 130 · 📋 160 - 30% open · ⏱️ 06.04.2021):

	```
	git clone https://github.com/rustgd/cgmath
	```
</details>
<details><summary><b><a href="https://github.com/twistedfall/opencv-rust">opencv-rust</a></b> (🥈14 ·  ⭐ 620) - Rust bindings for OpenCV 3 & 4. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/twistedfall/opencv-rust) (👨‍💻 26 · 🔀 64 · 📋 180 - 3% open · ⏱️ 06.04.2021):

	```
	git clone https://github.com/twistedfall/opencv-rust
	```
</details>
<details><summary><b><a href="https://github.com/image-rs/imageproc">imageproc</a></b> (🥈14 ·  ⭐ 350 · ➕) - Image processing operations. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/image-rs/imageproc) (👨‍💻 49 · 🔀 81 · 📋 140 - 37% open · ⏱️ 08.04.2021):

	```
	git clone https://github.com/image-rs/imageproc
	```
</details>
<details><summary><b><a href="https://github.com/rust-cv/cv">cv</a></b> (🥉11 ·  ⭐ 110) - Rust CV mono-repo. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/rust-cv/cv) (👨‍💻 4 · 🔀 7 · 📋 26 - 92% open · ⏱️ 15.03.2021):

	```
	git clone https://github.com/rust-cv/cv
	```
</details>
<details><summary>Show 6 hidden projects...</summary>

- <b><a href="https://github.com/EmbarkStudios/texture-synthesis">texture-synthesis</a></b> (🥈14 ·  ⭐ 1.4K) - Example-based texture synthesis written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/atomashpolskiy/rustface">rustface</a></b> (🥈14 ·  ⭐ 270) - Face detection library for the Rust programming language. <code>❗Unlicensed</code>
- <b><a href="https://github.com/mpizenberg/visual-odometry-rs">visual-odometry-rs</a></b> (🥉9 ·  ⭐ 28 · 💀) - Visual Odometry in Rust (vors). <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/visioncortex/visionmagic">visionmagic</a></b> (🥉9 ·  ⭐ 25 · 🐣) - Collection of vision & graphics algorithms. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jerry73204/rust-cv-convert">rust-cv-convert</a></b> (🥉7 ·  ⭐ 10 · 🐣) - Type conversion among popular Rust computer vision libraries. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/mermoldy/image-ssd">image-ssd</a></b> (🥉5 ·  ⭐ 1) - A Rust library for object detection via SSD MobileNet. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>
<br>

## Data Loading & Extraction

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for loading, collecting, and extracting data from a variety of data sources and formats._

<details><summary><b><a href="https://github.com/timberio/vector">vector</a></b> (🥇23 ·  ⭐ 6.9K) - A high-performance, high-reliability observability data pipeline. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code></summary>

- [GitHub](https://github.com/timberio/vector) (👨‍💻 130 · 🔀 460 · 📥 34K · 📋 3.3K - 35% open · ⏱️ 12.04.2021):

	```
	git clone https://github.com/timberio/vector
	```
</details>
<details><summary><b><a href="https://github.com/ritchie46/polars">polars</a></b> (🥈16 ·  ⭐ 1.4K) - Fast multi-threaded DataFrame library in Rust and Python. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/ritchie46/polars) (👨‍💻 22 · 🔀 63 · 📋 260 - 10% open · ⏱️ 12.04.2021):

	```
	git clone https://github.com/ritchie46/polars
	```
</details>
<details><summary><b><a href="https://github.com/nevi-me/rust-dataframe">rust-dataframe</a></b> (🥉10 ·  ⭐ 270) - A Rust DataFrame implementation, built on Apache Arrow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/nevi-me/rust-dataframe) (👨‍💻 4 · 🔀 18 · 📋 38 - 31% open · ⏱️ 26.10.2020):

	```
	git clone https://github.com/nevi-me/rust-dataframe
	```
</details>
<details><summary>Show 3 hidden projects...</summary>

- <b><a href="https://github.com/rayon-rs/rayon">rayon</a></b> (🥈15 ·  ⭐ 5K) - Rayon: A data parallelism library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jerry73204/rust-tfrecord">rust-tfrecord</a></b> (🥉9 ·  ⭐ 13) - A Rust crate that reads and writes tfrecord files. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/jerry73204/tch-serde">tch-serde</a></b> (🥉9 ·  ⭐ 3) - Serialize/Deserialize tch-rs types with serde. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>
<br>

## Graph Data

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for graph processing, clustering, embedding, and machine learning tasks._

<details><summary><b><a href="https://github.com/purpleprotocol/graphlib">graphlib</a></b> (🥉13 ·  ⭐ 150 · 💤) - Simple but powerful graph library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/purpleprotocol/graphlib) (👨‍💻 11 · 🔀 10 · 📋 26 - 19% open · ⏱️ 01.07.2020):

	```
	git clone https://github.com/purpleprotocol/graphlib
	```
</details>
<details><summary>Show 2 hidden projects...</summary>

- <b><a href="https://github.com/petgraph/petgraph">petgraph</a></b> (🥇15 ·  ⭐ 1.2K · ➕) - Graph data structure library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/sreeise/graph-rs">graph-rs</a></b> (🥉12 ·  ⭐ 17 · ➕) - Graph API client writen in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>

---

## Related Resources

- [**best-of-ml-python**](https://github.com/ml-tooling/best-of-ml-python): A ranked list of awesome machine learning Python libraries.
- [**best-of-ml-julia**](https://github.com/e-tony/best-of-ml-julia): A ranked list of awesome machine learning Julia libraries.

## Contribution

Contributions are encouraged and always welcome! If you like to add or update projects, choose one of the following ways:

- Open an issue by selecting one of the provided categories from the [issue page](https://github.com/e-tony/best-of-ml-rust/issues/new/choose) and fill in the requested information.
- Modify the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/blob/main/projects.yaml) with your additions or changes, and submit a pull request. This can also be done directly via the [Github UI](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml).

If you like to contribute to or share suggestions regarding the project metadata collection or markdown generation, please refer to the [best-of-generator](https://github.com/best-of-lists/best-of-generator) repository. If you like to create your own best-of list, we recommend to follow [this guide](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

For more information on how to add or update projects, please read the [contribution guidelines](https://github.com/e-tony/best-of-ml-rust/blob/main/CONTRIBUTING.md). By participating in this project, you agree to abide by its [Code of Conduct](https://github.com/e-tony/best-of-ml-rust/blob/main/.github/CODE_OF_CONDUCT.md).

## License

[![CC0](https://mirrors.creativecommons.org/presskit/buttons/88x31/svg/by-sa.svg)](https://creativecommons.org/licenses/by-sa/4.0/)
